/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999-2008 Bull S.A.S.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.webapp.jonasadmin.service.container;

import java.io.IOException;

import javax.management.ObjectName;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.objectweb.jonas.jmx.JonasObjectName;
import org.objectweb.jonas.webapp.jonasadmin.JonasBaseAction;

/**
 * @author Michel-Ange ANTON
 * @author S. Ali Tokmen, Malek Chahine: EJB statistics
 */
public class EditEjbCsStatisticAction extends JonasBaseAction {

// --------------------------------------------------------- Public Methods

    /**
     */
    public ActionForward executeAction(ActionMapping p_Mapping, ActionForm p_Form
        , HttpServletRequest p_Request, HttpServletResponse p_Response)
        throws IOException, ServletException {
        // Form used
        EjbContainersStatisticForm oForm = new EjbContainersStatisticForm();
        p_Request.setAttribute("ejbContainersStatisticForm", oForm);
        String applySettingsTo = p_Request.getParameter("applySettingsTo");
        
        try {
            // Object name used
            ObjectName oObjectName = JonasObjectName.ejbService();
            oForm.setTotalCurrentNumberOfBeanType(getIntegerAttribute(oObjectName
                , "TotalCurrentNumberOfBeanType"));
            oForm.setTotalCurrentNumberOfMDBType(getIntegerAttribute(oObjectName
                , "TotalCurrentNumberOfMDBType"));
            oForm.setTotalCurrentNumberOfSBFType(getIntegerAttribute(oObjectName
                , "TotalCurrentNumberOfSBFType"));
            oForm.setTotalCurrentNumberOfBMPType(getIntegerAttribute(oObjectName
                , "TotalCurrentNumberOfBMPType"));
            oForm.setTotalCurrentNumberOfSBLType(getIntegerAttribute(oObjectName
                , "TotalCurrentNumberOfSBLType"));
            oForm.setTotalCurrentNumberOfCMPType(getIntegerAttribute(oObjectName
                , "TotalCurrentNumberOfCMPType"));
            oForm.setTotalBusinessProcessingTime(getLongAttribute(oObjectName
                , "TotalBusinessProcessingTime"));
            oForm.setTotalProcessingTime(getLongAttribute(oObjectName
                , "TotalProcessingTime"));
            oForm.setMonitoringEnabled(getBooleanAttribute(oObjectName
                    , "MonitoringEnabled"));
            oForm.setNumberOfCalls(getIntegerAttribute(oObjectName
                    , "NumberOfCalls"));
            oForm.setAverageBusinessProcessingTime(getLongAttribute(oObjectName
                    , "AverageBusinessProcessingTime"));
            oForm.setAverageProcessingTime(getLongAttribute(oObjectName
                    , "AverageProcessingTime"));
            oForm.setWarningThreshold(getIntegerAttribute(oObjectName
                    , "WarningThreshold"));
            if (applySettingsTo !=null) {
            oForm.setApplySettingsTo(applySettingsTo);
            }
        }
        catch (Throwable t) {
            addGlobalError(t);
            saveErrors(p_Request, m_Errors);
            return (p_Mapping.findForward("Global Error"));
        }

        // Replace the normal forward if exists
        String sNextForward = (String) p_Request.getAttribute("NextForward");
        if (sNextForward == null) {
            sNextForward = "Ejb Containers Statistic";
        }
        // Forward to the jsp.
        return (p_Mapping.findForward(sNextForward));
    }
}
